type vertex = int
type graph = bool array array

let empty : graph = [||]

let add_vertex g =
  let l = Array.length g in
  let h = Array.make_matrix (l+1) (l+1) false in
    for i = 0 to l-1 do
      for j = 0 to l-1 do
	h.(i).(j) <- g.(i).(j)
      done
    done;
    (h, l+1)

let add_edge g i j =
  g.(i-1).(j-1) <- true; g

let size =
  Array.length

let has_edge g i j =
  g.(i-1).(j-1)

let successors g i =
  let (_,l) = Array.fold_left (fun (n,l) b -> if b then (n+1,n::l) else (n+1,l)) (1,[]) g.(i-1)
  in l
