type vertex = int
type graph = (vertex * (vertex list)) list

let empty = []

let add_vertex g =
  let i = (List.length g)+1 in
    ((i, [])::g, i)

let add_edge g i j =
  List.map (fun (v,e) -> if v = i then (v,j::e) else (v,e)) g

let size =
  List.length

let has_edge g i j =
  List.mem j (List.assoc i g)

let successors g i =
  List.assoc i g
